# Copyright 2014 Canonical Ltd.  This software is licensed under the
# GNU General Public License version 3 (see the file LICENSE).
from unittest import TestCase
from mojo.utils import secs2human


class UtilsTest(TestCase):
    def test_secs2human(self):
        self.assertEqual(secs2human(None), None)
        self.assertEqual(secs2human(False), None)
        self.assertEqual(secs2human(True), None)
        self.assertEqual(secs2human('some-string'), None)
        self.assertEqual(secs2human('671'), '11m 11s')
        self.assertEqual(secs2human(0), '0s')
        self.assertEqual(secs2human(0.01234567), '0s')
        self.assertEqual(secs2human(46.21), '46s')
        self.assertEqual(secs2human(46.61), '47s')
        self.assertEqual(secs2human(60), '1m')
        self.assertEqual(secs2human(71), '1m 11s')
        self.assertEqual(secs2human(600), '10m')
        self.assertEqual(secs2human(771), '12m 51s')
        self.assertEqual(secs2human(3600), '1h')
        self.assertEqual(secs2human(3660), '1h 1m')
        self.assertEqual(secs2human(7771), '2h 9m 31s')
        self.assertEqual(secs2human(86400), '24h')
        self.assertEqual(secs2human(87000), '24h 10m')
        self.assertEqual(secs2human(90061), '25h 1m 1s')
