# Copyright 2014 Canonical Ltd.  This software is licensed under the
# GNU General Public License version 3 (see the file LICENSE).
from setuptools import setup, find_packages
import mojo

long_description = """Mojo is a continuous integration and continuous delivery
system for Juju-based services."""


setup(
    name="mojo",
    version=mojo.__version__,
    description="A deployment workflow system for Juju",
    long_description=long_description,
    maintainer="Mojo Maintainers",
    maintainer_email="mojo-maintainers@lists.canonical.com",
    url="http://launchpad.net/mojo",
    # see requirements.txt for additional requirements including those not availble in pypi
    install_requires=["argcomplete",
                      "jinja2",
                      "jujuclient >= 0.0.7",
                      "juju-deployer >= 0.6.4",
                      "pylxd",
                      "python-cinderclient >= 1.0.0"],
    packages=find_packages(),
    classifiers=[
        "Development Status :: 2 - Pre-Alpha",
        "Programming Language :: Python",
        "Topic :: Internet",
        "Topic :: Software Development :: Libraries :: Python Modules",
        "Intended Audience :: Developers"],
    test_suite="mojo.tests",
    entry_points={
        "console_scripts": [
            'juju-check = mojo.juju.check:main',
            'juju-parse-status = mojo.juju.parse_status:main',
            'mojo = mojo.cli:main',
            'mojo-project-new = mojo.project_new:main',
            'mojo-project-destroy = mojo.project_destroy:main',
            'mojo-admin = mojo.cli:admin',
            'mojo-info = mojo.info:main',
            'mojo-vol = mojo.volattach:main']},
    include_package_data=True,
)
